module Syntax where

data El = Txt String | Ws | Tag Tag Document

data Tag = B | EM | I | PL | S | TT | U | Sz Int | C Char

type Document = [El]

instance Show El where
  showsPrec _ (Txt str)		=  foldl1 (flip (.)) (map showChar str)
  showsPrec _ Ws		= showChar ' '
  showsPrec _ (Tag t d)		= showChar '<' . shows t . showChar '>' . (foldr1 (flip (.)) (map shows d))  . showString "</" . shows t . showString ">"

instance Show Tag where
  showsPrec _ B   		= showString "B"
  showsPrec _ EM  		= showString "EM"
  showsPrec _ I			= showString "I"
  showsPrec _ PL 	 	= showString "PL"
  showsPrec _ S 		= showString "S"
  showsPrec _ TT 		= showString "TT"
  showsPrec _ U 		= showString "U" 
  showsPrec _ (Sz int) 		= showsPrec 0 int 
  showsPrec _ (C c) 		= showChar c

getTag :: Char -> Tag

getTag 'B' = B
getTag 'I' = I
getTag 'S' = S
getTag 'U' = U

getTag '0' = Sz 0
getTag '1' = Sz 1
getTag '2' = Sz 2
getTag '3' = Sz 3
getTag '4' = Sz 4
getTag '5' = Sz 5
getTag '6' = Sz 6
getTag '7' = Sz 7
getTag '8' = Sz 8
getTag '9' = Sz 9

getTag 'r' = C 'r'
getTag 'g' = C 'g'
getTag 'b' = C 'b'
getTag 'c' = C 'c'
getTag 'm' = C 'm'
getTag 'y' = C 'y'
getTag 'k' = C 'k'
getTag 'w' = C 'w'
